//+------------------------------------------------------------------+
//|                                                     exp_Lego.mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Seletsky R.V."
#property link      "http://www"

//-------------------------------------------------------------------+
//                                                                   |
//--------------------------------------------------------------- 1--+
extern   string    1              =  "----    ---- ";

extern   string   b1                    =  "---- ---- ---- ----Ma";
extern bool  otkr_MA    =true;
extern bool  zakr_MA    =true;
extern double MA1           =14;
extern double MA2           =67;

extern double Shift_ma      =1;

extern   string   c1                    =  "---- ---- ---- ----";
extern bool   otkr_Stoh   =false;
extern bool   zakr_Stoh   =false;
extern double per_K=5;
extern double per_D=3;
extern double slow=3;
extern double zoneBUY=30;
extern double zoneSELL=70;

extern   string   d1                    =  "---- ---- ---- ----Awesome";
extern bool   otkr_AO   =false;
extern bool   zakr_AO   =false;

extern   string   e1                    =  "---- ---- ---- ----Accelerator";
extern bool   otkr_AC   =false;
extern bool   zakr_AC   =false;

extern   string   f1                    =  "---- ---- ---- ----Demarker";
extern bool   otkr_Dema   =false;
extern bool   zakr_Dema   =false;
extern double DeMa_period=14;
extern double niz_ur=0.3;
extern double verx_ur=0.7;

extern   string   g1                    =  "---- ---- ---- ----CCI";
extern bool   otkr_CCI   =false;
extern bool   zakr_CCI   =false;
extern double CCI_period=14;
extern   string    2              =  "----    ---- ";
            
extern double StopLoss    =200;      // SL   
extern double TakeProfit  =200;      //    
extern double Lts0        =0.1;     //   . 
extern double IK          =1;      //  Lts0 * IK       

extern bool    SleepBars  =true;    //      2000 

bool Work=true;                    //   .
bool OrderSal;
string Symb;                       //  . 

//--------------------------------------------------------------- 2 --

//-----------------------------------------------------------
int start()
  {
   int
  
   Total,                           //     
   Tip=-1,                          //  .  (B=0,S=1)
   Ticket;                          //  
  
   double
   Lot,                             // .   .
   Lts,                             // .   .
   lot,
   Min_Lot,                         //   
   Step,                            //    
   Free,                            //   
   One_Lot,                         //   
   Price,                           //   
   SL,                              // SL   
   TP,                              // TP  
   //--
   ma_By,ma_Sell,Stoh_By,Stoh_Sell,AO_By,AO_Sell,AC_By,AC_Sell,Cls_ma_Sell,Cls_ma_By,Cls_Stoh_Sell,Cls_Stoh_By,
   Cls_AO_Sell,Cls_AO_By,Cls_AC_Sell,Cls_AC_By,Dema_By,Cls_Dema_Sell,Dema_Sell,Cls_Dema_By,CCI_By,CCI_Sell,Cls_CCI_Sell,Cls_CCI_By;
   
 bool
   Modific=true,
   Ans  =false,                     //    
   Cls_B=false,                     //     Buy
   Cls_S=false,                     //     Sell
   Opn_B=false,                     //     Buy
   Opn_S=false,                     //     Sell
   S_Bar=false;                 //   Sleep Bar
   
//------------------------------------------------------------------------------ 
   
  
//--------------------    ------------------ 2 -
  
int time0 = 0;                                                  //   
for(int t0 = OrdersHistoryTotal();t0>=0;t0--)                   //    
if(OrderSelect(t0, SELECT_BY_POS,MODE_HISTORY )==true)          //      (i)      (    )
    {
      if( iTime(NULL,0,0)-OrderOpenTime() <2000 && SleepBars==true) //  
                 {                                         
                    S_Bar=true;                                //    iTime(NULL,0,1)
                    Alert("... ");                                           
                 }
      //    return(0); 
           }
//----------------------------------------------------------------------
  
   
//-------------------- .-------------------------- 3 -    

   if(Bars<2)                       //  
     {
      Alert("   .   .");
      return;                                   //   start()
     }
   if(Work==false)                              //  
     {
      Alert(" .   .");
      return;                                   //   start()
     }
//------------------------------------------------------------------------------    
     
     
//------------------------------ --------------------------------- 4 --
Symb=Symbol();                               //  ..
   Total=0;                                     //  
   for(int i=1; i<=OrdersTotal(); i++)          //   
     {
      if (OrderSelect(i-1,SELECT_BY_POS)==true) //   
        {                                       //  :
         if (OrderSymbol()!=Symb)continue;      //   . 
         if (OrderType()>1)                     //  
           {
            Alert("  .   .");
            return;                             //   start()
           }
         Total++;                               //  . 
         if (Total>1)                           //    
           {
            Alert("  .   .");
            return;                             //   start()
           }
         Ticket=OrderTicket();                  //  . .
         Tip   =OrderType();                    //   .
         Price =OrderOpenPrice();               //  . .
         SL    =OrderStopLoss();                // SL  .
         TP    =OrderTakeProfit();              // TP  .
         Lot   =OrderLots();                    //  
        }
     }  
  
 
//--------------------------- ------------------------------------ 5 --
     
//:------------------------------------
 if(otkr_MA==true)
              {
               if( iMA(NULL,0,MA1,0,MODE_SMA,PRICE_CLOSE,Shift_ma)>iMA(NULL,0,MA2,0,MODE_SMA,PRICE_CLOSE,Shift_ma))
                 {
                  ma_By =true;
                 } 
               if(iMA(NULL,0,MA1,0,MODE_SMA,PRICE_CLOSE,Shift_ma)<iMA(NULL,0,MA2,0,MODE_SMA,PRICE_CLOSE,Shift_ma))
                 {
                  ma_Sell =true;
                 } 
               }
               
 if(zakr_MA==true)
              {
               if( iMA(NULL,0,MA1,0,MODE_SMA,PRICE_CLOSE,Shift_ma)>iMA(NULL,0,MA2,0,MODE_SMA,PRICE_CLOSE,Shift_ma))
                 {
                  Cls_ma_Sell=true;
                 } 
               if(iMA(NULL,0,MA1,0,MODE_SMA,PRICE_CLOSE,Shift_ma)<iMA(NULL,0,MA2,0,MODE_SMA,PRICE_CLOSE,Shift_ma))
                 {
                  Cls_ma_By=true;
                 } 
               }             
//:-------------------------------
 if(otkr_Stoh==true)
          {
               if(iStochastic(NULL,0,per_K,per_D,slow,MODE_LWMA,1,0,1)>iStochastic(NULL,0,per_K,per_D,slow,MODE_LWMA,1,1,1)
                  && iStochastic(NULL,0,per_K,per_D,slow,MODE_LWMA,1,1,1)<zoneBUY)
                   {
                   Stoh_By =true;
                   }
              if(iStochastic(NULL,0,per_K,per_D,slow,MODE_LWMA,1,0,1)<iStochastic(NULL,0,per_K,per_D,slow,MODE_LWMA,1,1,1)
                 && iStochastic(NULL,0,per_K,per_D,slow,MODE_LWMA,1,1,1)>zoneSELL)
                  {
                  Stoh_Sell =true;
                  } 
               }      
               
 if(zakr_Stoh==true)
          {
              if(iStochastic(NULL,0,per_K,per_D,slow,MODE_LWMA,1,0,1)>iStochastic(NULL,0,per_K,per_D,slow,MODE_LWMA,1,1,1)
                 && iStochastic(NULL,0,per_K,per_D,slow,MODE_LWMA,1,1,1)<zoneBUY)
                   {
                   Cls_Stoh_Sell=true;
                   }
             if(iStochastic(NULL,0,per_K,per_D,slow,MODE_LWMA,1,0,1)<iStochastic(NULL,0,per_K,per_D,slow,MODE_LWMA,1,1,1)
                 && iStochastic(NULL,0,per_K,per_D,slow,MODE_LWMA,1,1,1)>zoneSELL)
                  {
                  Cls_Stoh_By=true;
                  } 
               }               
//Awesome:--------------------------------
  if(otkr_AO==true)
        {
              if(iAO(NULL,0,0)>iAO(NULL,0,1))
                  {
                   AO_By =true;
                  }    
              if(iAO(NULL,0,0)<iAO(NULL,0,1))
                  {
                   AO_Sell =true;
                  } 
               } 
               
if(zakr_AO==true)
        {
           if(iAO(NULL,0,0)>iAC(NULL,0,1))
                  {
                   Cls_AO_Sell=true;
                  }    
            if(iAO(NULL,0,0)<iAC(NULL,0,1))
                  {
                   Cls_AO_By=true;
                  } 
               }                
//Accelerator:---------------------------
   if(otkr_AC==true)
               {          
               if (iAC(NULL,0,0)>=0 && iAC(NULL,0,0)>iAC(NULL,0,1) && iAC(NULL,0,1)>iAC(NULL,0,2) || iAC(NULL,0,0)<=0 && iAC(NULL,0,0)>iAC(NULL,0,1) && iAC(NULL,0,1)>iAC(NULL,0,2) && iAC(NULL,0,2)>iAC(NULL,0,3)) 
                  {
                   AC_By =true;
                  }    
               if (iAC(NULL,0,0)<=0 && iAC(NULL,0,0)<iAC(NULL,0,1) && iAC(NULL,0,1)<iAC(NULL,0,2) || iAC(NULL,0,0)>=0 && iAC(NULL,0,0)<iAC(NULL,0,1) && iAC(NULL,0,1)<iAC(NULL,0,2) && iAC(NULL,0,2)<iAC(NULL,0,3)) 
                  {
                   AC_Sell =true;
                  }  
                }   
            
  if(zakr_AC==true)
              {          
              if (iAC(NULL,0,0)>=0 && iAC(NULL,0,0)>iAC(NULL,0,1) && iAC(NULL,0,1)>iAC(NULL,0,2) || iAC(NULL,0,0)<=0 && iAC(NULL,0,0)>iAC(NULL,0,1) && iAC(NULL,0,1)>iAC(NULL,0,2) && iAC(NULL,0,2)>iAC(NULL,0,3)) 
                  {
                    Cls_AC_Sell=true;
                  }    
             if (iAC(NULL,0,0)<=0 && iAC(NULL,0,0)<iAC(NULL,0,1) && iAC(NULL,0,1)<iAC(NULL,0,2) || iAC(NULL,0,0)>=0 && iAC(NULL,0,0)<iAC(NULL,0,1) && iAC(NULL,0,1)<iAC(NULL,0,2) && iAC(NULL,0,2)<iAC(NULL,0,3)) 
                  {
                   Cls_AC_By=true;
                  }  
               }   
 //Demarker:---------------------------- 
 if(otkr_Dema==true) 
             {      
              if (iDeMarker(NULL, 0, DeMa_period, 0)<niz_ur) 
                  {
                   Dema_By =true;
                  }    
             if (iDeMarker(NULL, 0, DeMa_period, 0)>verx_ur) 
                  {
                   Dema_Sell =true;
                  }  
               }
          
 if(zakr_Dema==true) 
              {      
            if (iDeMarker(NULL, 0, DeMa_period, 0)<niz_ur) 
                  {
                   Cls_Dema_Sell=true;
                  }    
            if (iDeMarker(NULL, 0, DeMa_period, 0)>verx_ur) 
                  {
                   Cls_Dema_By=true;
                  }  
               }     
  //CCI:-------------------------------
 if(otkr_CCI==true)
             {      
            if (iCCI(NULL, 0,CCI_period,PRICE_MEDIAN, 1)<-100) 
                  {
                   CCI_By =true;
                  }    
            if (iCCI(NULL, 0,CCI_period,PRICE_MEDIAN,1)>100) 
                  {
                   CCI_Sell =true;
                  } 
               }                   
      
   if(zakr_CCI==true)
               {      
           if (iCCI(NULL, 0,CCI_period,PRICE_MEDIAN, 1)<-100) 
                  {
                   Cls_CCI_Sell=true;
                  }    
           if (iCCI(NULL, 0,CCI_period,PRICE_MEDIAN,1)>100) 
                  {
                   Cls_CCI_By=true;
                  } 
               }                   
                               
                                                                   
//-------------------------------------------------------------------------------//
  if (ma_By ==true||otkr_MA==false && Stoh_By ==true||otkr_Stoh==false &&
      AO_By ==true||otkr_AO==false && AC_By ==true||otkr_AC==false && Dema_By ==true||otkr_Dema==false &&
      CCI_By ==true||otkr_CCI==false)    
     {                                          
      Opn_B=true;                               //  . Buy
     }
//---------    
  if (ma_Sell==true||otkr_MA==false && Stoh_Sell ==true||otkr_Stoh==false &&
      AO_Sell ==true||otkr_AO==false && AC_Sell==true||otkr_AC==false && Dema_Sell ==true||otkr_Dema==false &&
      CCI_Sell ==true||otkr_CCI==false) 
     {                                          
      Opn_S=true;                               //  . Sell
     } 
//-------------------------------------------------------------------------------//
if (  Cls_ma_By==true||zakr_MA==false && Cls_Stoh_By==true||zakr_Stoh==false &&
      Cls_AO_By==true||zakr_AO==false && Cls_AC_By==true||zakr_AC==false && Cls_Dema_By==true||zakr_Dema==false &&    
     Cls_CCI_By==true||zakr_CCI==false)
     {                                          
      Cls_B=true;                               //  . Buy
     }   
 if ( Cls_ma_Sell==true||zakr_MA==false && Cls_Stoh_Sell==true||zakr_Stoh==false &&
      Cls_AO_Sell==true||zakr_AO==false && Cls_AC_Sell==true||zakr_AC==false && Cls_Dema_Sell==true||zakr_Dema==false &&    
     Cls_CCI_Sell==true||zakr_CCI==false)             
     {                                          
      Cls_S=true;                               //  . Sell
     } 
  
  
  
//----------------------------- ---------------------------------- 6 --
  
   while(true)                                  //   .
     {
      if (Tip==0 && Cls_B==true)                //   Buy..  Buy
        {                                       //   
         Alert("  Buy ",Ticket,".  ..");
         RefreshRates();                        //  
         Ans=OrderClose(Ticket,Lot,Bid,2);      //  Buy
         if (Ans==true)                         //  :)
           {
            Alert ("  Buy ",Ticket);
            
            break;                              //    
           }
         if (Fun_Error(GetLastError())==1)      //  
            continue;                           //  
         return;                                //   start()
        }

      if (Tip==1 && Cls_S==true)                //   Sell..  Sell
        {                                       //    
         Alert("  Sell ",Ticket,".  ..");
         RefreshRates();                        //  
         Ans=OrderClose(Ticket,Lot,Ask,2);      //  Sell
         if (Ans==true)                         //  :)
           {
            Alert ("  Sell ",Ticket);
            
            break;                              //    
           }
         if (Fun_Error(GetLastError())==1)      //  
            continue;                           //  
         return;                                //   start()
        }
      break;                                    //   while
     }
    
 
//----------------------------- ---------------------------------- 7 --
   
RefreshRates();                              //     
 
    int time = 0;double profit = 0;           //          

for(int t = OrdersHistoryTotal();t>=0;t--)   //    
{
  if(OrderSelect(t,SELECT_BY_POS,MODE_HISTORY))//     (i)      (    )
  {
    if(OrderSymbol() == Symbol())       //        
    {
      if(time<OrderCloseTime())        //(      time)
       
      {
        time=OrderCloseTime();          //     -    
        profit=OrderProfit();          //    
        lot   =OrderLots();                    //  
        
  
      }
    }
  }
}

if(profit == 0)  {Lts=Lts0;}     //            
if(profit >= 0)  {Lts=Lts0;}     //     ,  
if(profit <  0)  {Lts=lot*IK;}   //     

    
         if (Lts*One_Lot > Free)                      //   .     
         {     
          Alert("     ", Lts," ");      
          return;                                   //   start()     
          }
   
//------------------------------------------------------------------------------ 


//------------------------------ --------------------------------- 8 --

   while(true)                                  //   .
   
     {
      if (Total==0 && Opn_B==true && Cls_B==false)              //  .  +
        {                                       //  . Buy
         RefreshRates();                        //  
         SL=Bid - New_Stop(StopLoss)*Point;     //  SL .
         TP=Bid + New_Stop(TakeProfit)*Point;   //  TP .
         Alert("  Buy.  ..");
         Ticket=OrderSend(Symb,OP_BUY,Lts,Ask,3,SL,TP);// Buy
         if (Ticket > 0)                        //  :)
           {
            Alert ("  Buy ",Ticket);
            return;                             //   start()
           }
         if (Fun_Error(GetLastError())==1)      //  
            continue;                           //  
         return;                                //   start()
        }
      if (Total==0 && Opn_S==true && Cls_S==false)              //  .  +
        {                                       //  . Sell
         RefreshRates();                        //  
         SL=Ask + New_Stop(StopLoss)*Point;     //  SL .
         TP=Ask - New_Stop(TakeProfit)*Point;   //  TP .
         Alert("  Sell.  ..");
         Ticket=OrderSend(Symb,OP_SELL,Lts,Bid,3,SL,TP);// Sel
         if (Ticket > 0)                        //  :)
           {
            Alert ("  Sell ",Ticket);
            return;                             //   start()
           }
         if (Fun_Error(GetLastError())==1)      //  
            continue;                           //  
         return;                                //   start()
        }
      break;                                    //   while
     }
   return;                                      //   start()
  }
  
//------------------------------------------------------------------------------   

//---------------------------  ------------------------------------ 10 --
int Fun_Error(int Error)                      
  {
   switch(Error)
     {                                          //              
      case  4: Alert("  .   ..");
         Sleep(3000);                           //  
         return(1);                             //   
      case 130:Alert(" ");
         while(RefreshRates()==false)           //   
            Sleep(1);                            //   
         return(1);                             //      
      case 135:Alert(" .   ..");
         RefreshRates();                        //  
         return(1);                             //   
      case 136:Alert(" .   ..");
         while(RefreshRates()==false)           //   
            Sleep(1);                           //   
         return(1);                             //   
      case 137:Alert(" .   ..");
         Sleep(3000);                           //  
         return(1);                             //   
      case 146:Alert("  .  ..");
         Sleep(500);                            //  
         return(1);                             //   
         //  
      case  2: Alert(" .");
         return(0);                             //   
      case  5: Alert("  .");
         Work=false;                            //   
         return(0);                             //   
      case 64: Alert(" .");
         Work=false;                            //   
         return(0);                             //   
      case 133:Alert(" .");
         return(0);                             //   
      case 134:Alert("    .");
         return(0);                             //   
      default: Alert("  ",Error); //     
         return(0);                             //   
     }
  }
//-------------------------------------------------------------- 11 --

int New_Stop(int Parametr)                      //  -.
  {
   int Min_Dist=MarketInfo(Symb,MODE_STOPLEVEL);// . 
   if (Parametr<Min_Dist)                       //   .
     {
      Parametr=Min_Dist;                        //  .
      Alert("  -.");
     }
   return(Parametr);                            //  
  }
//---------------------------